"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const react_1 = require("react");
exports.ProstoreSsrContext = react_1.createContext(null);
class ProstoreSsrManager {
    constructor({ isServer, initialStates }) {
        this.isServer = false;
        this.states = {};
        this.promises = new Set();
        this.disabled = false;
        this.isServer = isServer || false;
        this.states = initialStates || this.states;
    }
    registerPromise(promise) {
        this.promises.add(promise);
        promise.then(() => {
            this.promises.delete(promise);
        });
    }
    hasPromises() {
        return this.promises.size > 0;
    }
    waitForCurrentPromises() {
        return Promise.all(this.promises);
    }
    getState(key) {
        if (this.disabled)
            return null;
        return this.states[key];
    }
    setState(key, value) {
        if (this.disabled)
            return;
        this.states[key] = value;
    }
    getStates() {
        return this.states;
    }
    setDisabled(value) {
        this.disabled = value;
    }
}
exports.ProstoreSsrManager = ProstoreSsrManager;
//# sourceMappingURL=ProstoreSsrContext.js.map